type term = I | S | K | App of (term * term)                    
                                                               
let skomega = App (App (App (S,I), I), App (App (S,I), I))                
let test = App (App (K,I), skomega)
                                                                      
let reduce_one_step (t:term):term = match t with                    
    App(I,a) -> a                                                    
  | App(App(K,a),b) -> a                                             
  | App(App(App(S,a),b),c) -> App(App(a,c),App(b,c))                       
  | _ -> t                                                     
                                                               
let is_redex (t:term):bool = not (t = reduce_one_step t)        
                                                                      
let rec reduce (t:term):term = match t with                        
    I -> I                                                     
  | K -> K                                                     
  | S -> S                                                     
  | App (a, b) ->                                                   
      let t' = App (reduce a, reduce b) in                      
        if (is_redex t') then reduce (reduce_one_step t')     
                         else t'                               

let rec reduce_lazy (t:term):term = match t with                        
    I -> I                                                     
  | K -> K                                                     
  | S -> S                                                     
  | App (a, b) ->                                                   
      let t' = App (reduce_lazy a, b) in                      
        if (is_redex t') then reduce_lazy (reduce_one_step t')     
                         else t'                               
